from fastapi.routing import APIRouter
from fastapi.requests import Request

from api_validations.validations_request import (
    PatchRecord,
    ListOptions,
    InsertBuild,
    UpdateBuild,
)

from api_services.redis.auth_actions.token import parse_token_object_to_dict


build_route = APIRouter(prefix="/building/build", tags=["Building"])
build_route.include_router(build_route, include_in_schema=True)


@build_route.post(path="/list", summary="List Build Active/Delete/Confirm Build")
def building_build_list(request: Request, list_options: ListOptions):
    token_dict = parse_token_object_to_dict(request=request)
    return token_dict.available_event(list_options=list_options, token_dict=token_dict)


@build_route.post(path="/create", summary="Create Build with given auth levels")
def building_build_create(request: Request, data: InsertBuild):
    token_dict = parse_token_object_to_dict(request=request)
    return token_dict.available_event(data=data, token_dict=token_dict)


@build_route.post(path="/update/{build_uu_id}", summary="Update Build Parts with given auth levels")
def building_build_update(request: Request, build_uu_id: str, data: UpdateBuild):
    token_dict = parse_token_object_to_dict(request=request)
    return token_dict.available_event(data=data, build_uu_id=build_uu_id, token_dict=token_dict)


@build_route.patch(path="/patch/{build_uu_id}", summary="Patch Build Parts with given auth levels")
def building_build_patch(request: Request, build_uu_id: str, data: PatchRecord):
    token_dict = parse_token_object_to_dict(request=request)
    return token_dict.available_event(data=data, build_uu_id=build_uu_id, token_dict=token_dict)
